//--------------------------------
//  Siemens C-35
//
//  -UNICODE-
//
//Author:   
//E-mail: raxp@mail.zp.ua
//C : -
//--------------------------------

unit pdum;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, Mask, Buttons, ExtCtrls, Spin,
  IO,PDU7bits;

type
  Tpduf = class(TForm)
    num: TMaskEdit;
    txt: TMaskEdit;
    pdu: TMaskEdit;
    SZ: TMaskEdit;
    typ: TMemo;
    cms: TComboBox;
    Label2: TLabel;
    Label3: TLabel;
    Label1: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Bevel1: TBevel;
    tpdu: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton1: TSpeedButton;
    cmgr: TSpinEdit;
    SpeedButton2: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    ind: TShape;
    fsms: TCheckBox;
    ksz: TMaskEdit;
    Panel1: TPanel;
    SpeedButton3: TSpeedButton;
    SpeedButton7: TSpeedButton;
    Memo1: TMemo;
    Memo2: TMemo;
    procedure tpduClick(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var pduf: Tpduf;
    ac: boolean;

implementation
{$R *.dfm}

//===
function cnv(s: string):string;
var i: integer;
begin
 delete(s,1,1);
 if length(s) mod 2>0 then s:=s + 'F';
 i:= 1;
 while (i<length(s)+1) do begin
  result:= result + s[i+1]+s[i];
  inc(i);inc(i)
 end
end;
function ucs2(s: string): string;
var i,k: integer;
begin
 for i:=1 to length(s) do begin
  k:= ord(s[i]);
  if k>=192 then k:= k + 1040 - 192;
  result:= result + inttohex(k,4)
 end
end;
function tcod: string;
begin
 if pduf.fsms.Checked then result:= 'F8'
  else result:= '08'
end;
function cpdu(ksz,sz,num,msg: string): string;
begin
 result:= inttohex(length(sz),2) +      // 07=  SMSC
          '91' +                        // 91=  SMSC
          cnv(ksz + sz) +               // 97103701F0=+790173100     F
          '01' +                        // 01=PDU Type: MTI=01 ->  SMS
          '00' +                        // 00=MR - ,    SMSC
          inttohex(length(num)-1,2) +   //   -1
          '91' +                        // 91= 
          cnv(num) +                    // 9710276338F6=+79017236836 -  
          '00' +                        // 00=PID   
          tcod +                        // F8/08=DCS    /: 
          inttohex(length(msg)*2,2)+    //  
          ucs2(msg)                     // 
end;
procedure Tpduf.tpduClick(Sender: TObject);
begin
 if (sz.Text='')and(ksz.Text='') then caption:= '  !!!      SIM'
  else caption:= '  PDU conversion TEST [Siemens C-35]';
 pdu.Text:= cpdu(ksz.Text, sz.Text,num.Text, txt.Text)
end;

procedure Tpduf.SpeedButton4Click(Sender: TObject);
begin
 ac:= not ac;
 ind.Brush.Color:= clBtnFace;
 if (ac) then begin
  if not (opencom(cms.Text,2048,2048,19200)) then ind.Brush.Color:= clBtnFace
   else ind.Brush.Color:= clwhite;
  sendcom('AT+CGMI'+#13+#10);
  application.ProcessMessages;
  sleep(250);
  typ.Lines.Add(trim(readcom));
  sendcom('AT+CSCS=?'+#13+#10);
  sleep(250);
  typ.Lines.Add(trim(readcom));
  sendcom('AT+CSCA?'+#13+#10);
  application.ProcessMessages;
  sleep(250);
  typ.Lines.Add(trim(readcom))
 end else closecom
end;

procedure Tpduf.SpeedButton5Click(Sender: TObject);
begin
 sendcom('AT+CMGR='+ inttostr(cmgr.value) +#13+#10);
 application.ProcessMessages;
 sleep(2500);
 typ.Lines.Add(trim(readcom))
end;


procedure Tpduf.SpeedButton6Click(Sender: TObject);
begin
 if pdu.Text<>'' then begin
  sendcom('AT+CMGS='+inttostr(length(txt.text)*2)+#13+#10);
  application.ProcessMessages;
  sleep(1000);
  typ.Lines.Add(trim(readcom));
  sendcom(pdu.Text+#26);
  sleep(5000);
  typ.Lines.Add(trim(readcom))
 end
end;

procedure Tpduf.SpeedButton1Click(Sender: TObject);
const simv = 'ŨABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"-* ';
ucs:array[1..128] of string = (
            '0410','0411','0412','0413','0414','0415','00A8','0416','0417',
            '0418','0419','041A','041B','041C','041D','041E','041F','0420',
            '0421','0422','0423','0424','0425','0426','0427','0428','0429',
            '042C','042A','042D','042E','042F','0430','0431','0432','0433',
            '0434','0435','00B8','0436','0437','0438','0439','043A','043B',
            '043C','043D','043E','043F','0440','0441','0442','0443','0444',
            '0445','0446','0447','0448','0449','044D','044E','044F','0041',
            '0042','0043','0044','0045','0046','0047','0048','0049','004A',
            '004B','004C','004D','004E','004F','0050','0051','0052','0053',
            '0054','0055','0056','0057','0058','0059','005A','0061','0062',
            '0063','0064','0065','0066','0067','0068','0069','006A','006B',
            '006C','006D','006E','006F','0070','0071','0072','0073','0074',
            '0075','0076','0077','0078','0079','007A','0030','0031','0032',
            '0033','0034','0035','0036','0037','0038','0039','0022','002D',
            '002A','0020');
var i: integer;
begin
 pdu.Text:= '';
 for i:=1 to length(txt.Text) do
  pdu.Text:= pdu.Text + ucs[pos(txt.Text[i],simv)]
end;

procedure Tpduf.SpeedButton3Click(Sender: TObject);
begin
 Memo2.Text:= EncodePDU7bits(Memo1.Text);
 memo1.Clear
end;

procedure Tpduf.SpeedButton7Click(Sender: TObject);
begin
 Memo1.Text:= DecodePDU7bits(Memo2.Text)
end;

end.
