/* GSM - */

#include <avr/io.h>

#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <string.h>
#include "uart.h"
#include "iotn2313.h"

//#define nop() {asm("nop");}
#define sbi(port,bit)  port |=  (1<<(bit)) 
#define cbi(port,bit)  port &= ~(1<<(bit)) 
#define outp(port,bit) port = bit
#define inp(port) port

#define SIZERX 32
char arRx[SIZERX];
unsigned char posRx = 0;

const char szSTART[] PROGMEM = "AT+CMGS=54\x0d";
const char sz0[] PROGMEM = "\x1a";
const char sz1[] PROGMEM = "\x1a";
const char sz2[] PROGMEM = "079183609310000001000C91835050391443000836041D043504420020043F043804420430043D0438044F0020043A043E043D04420440043E043B043B043504400430002000470053004D\x1a";
const char sz3[] PROGMEM = "079183609310000001000C91835050391443000836041D043504420020043F043804420430043D0438044F0020043A043E043D04420440043E043B043B043504400430002000470053004D\x1a";
const char sz4[] PROGMEM = "\x1a";
const char sz5[] PROGMEM = "\x1a";
const char sz6[] PROGMEM = "\x1a";
const char sz7[] PROGMEM = "\x1a";
const char sz8[] PROGMEM = "\x1a";

const char szATCPBS[] PROGMEM  = "AT+CPBS=SM\x0d";	//    SIM
const char szATCPBR1[] PROGMEM = "AT+CPBR=1\x0d"; 	//   1  SIM
const char szATCPBR2[] PROGMEM = "AT+CPBR=2\x0d"; 	//   2  SIM
//const char szATCSCA[] PROGMEM  = "AT+CSCA?\x0d"; 	//   sms 

//PARAM MODEM TC-75
//const char sZON[] PROGMEM = "\x05\x02\x07\x06\x0c";//ON-OFF
//const char sZOF[] PROGMEM = "AT+SKPD=12,20";		 //OFF (10,12)
const char sAT1[] PROGMEM = "ATD";
const char sAT2[] PROGMEM = ";\x0d";
const char sATH[] PROGMEM = "ATH\x0d";

char sSMSNUM1[13] = "+380505934134";	//   
char sSMSNUM2[13] = "+380506624989";	// ---


//void get_num(unsigned char n);
void testSMS(char cause);
void Init(void);
void DiagOut(unsigned char n,unsigned int time);
void wait_1ms(unsigned char ms);
void wait_1s(unsigned char s);


/*char cnv(char* s) // to MODNUM
{
	unsigned char i = 2;
	char temp;

	if (strlen(s)!= 13) {s[strlen(s)+1] = s[strlen(s)] + "F";}
	while (i<strlen(s)+1)
	 {
		temp = temp + s[i+1] + s[i];
  		i++; i++;
	 }
	 return temp;
}

char cnv2(char* s) // to UCS2
{
	unsigned char i,k;
	char temp;
	for(i=1; i<strlen(s); i++)
	 {
 		k = s[i]; //k = strchr(s, i); -  i-    s //char *k; static char s[] = "nrtfbae",
  		if (k > 0xC0)|(k == 0xC0)
		{
			k = k + 0x410 - 0xC0;
		} 
		temp = temp + k;
	 }
	return temp;  
}

char cnv3(char* s) // to UCS2
{
	char simv[] = "ŨABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"-* "; // 
	char temp;

//	for (i=1; i<strlen(s); i++) {temp = temp + ucs[strstr(simv, s[i])];}
	return temp;
}
char* cpdu(char sz,char num,char msg) // to PDU
{
	char* temp = '07' +         //07=06   SMSC + 1   SMSC
          		 '91' +          //91= SMSC
          		 cnv(sz) +       //97103701F0=+790173100     F
          		 '01' +          //01=PDU Type: MTI=01 ->  SMS
          		 '00' +          //00=MR - ,    SMSC
          		 strlen(num)-1 + //0B=  -1 (10   )
          		 '91' +          //91= 
          		 cnv(num) +      //9710276338F6=+79017236836 -  
          		 '00' +          //00=PID   
          		 '08' +          //08=DCS   :  
          		 strlen(msg)*2 + //02= 
          		 cnv2(msg);      //0410=: ""
	return temp;
}*/
/*
function cnv(s: string):string;
var i: integer;
begin
 i:= 2;
 if length(s)<>13 then s:=s + 'F';
 while (i<length(s)+1) do begin
  result:= result + s[i+1]+s[i];
  inc(i);inc(i)
 end
end;
function cnv2(s: string): string;
var i,k: integer;
begin
 for i:=1 to length(s) do begin
  k:= ord(s[i]);
  if k>=192 then k:= k + 1040 - 192; //0xC0 0x410
  result:= result + inttohex(k,4)
 end;
end;
function cpdu(sz,num,msg: string): string;
begin
 result:= '07' +                        //07   SMSC + 1   SMSC
          '91' +                        //91= SMSC
          cnv(sz) +                     //97103701F0=+790173100     F
          '01' +                        //01=PDU Type: MTI=01 ->  SMS
          '00' +                        //00=MR - ,    SMSC
          inttohex(length(num)-1,2) +   //0B=  -1
          '91' +                        //91= 
          cnv(num) +                    //9710276338F6=+79017236836 -  
          '00' +                        //00=PID   
          '08' +                        //08=DCS   :  
          inttohex(length(msg)*2,2)+    //02= , 1  - 2 
          cnv2(msg)                     //
end;
*/
/*
void get_num(unsigned char n)
{
	//=== AT+CPBR=1   1  ===
	if (n==1) {UART_outstr_P(szATCPBR1);}
	 else UART_outstr_P(szATCPBR2);
	  //else UART_outstr_P(szATCSCA);
	//    +CPBR: 1,"+380505934134",145,"Number1 "\x0dOK
	wait_1ms(250);	wait_1ms(250);
	
	char nRecv = 0;
	char* pBuf = UART_Recv(&nRecv);
	unsigned char cp = 0;
	while(pBuf[cp])
		{
			if(pBuf[cp]=='B') //
				break;
			cp++;
		}
	while(pBuf[cp])
		{
			if(pBuf[cp]=='+')
			{
				//  "+
				DiagOut(10,15);
				char z;
				for(z=1; z<14; z++) {
										if (n==1) {sSMSNUM1[z-1] = pBuf[cp+z-1];}
											else {sSMSNUM2[z-1] = pBuf[cp+z-1];};
												//else sSMSC[z-1] = pBuf[cp+z-1];
									}
				break;
			}
			cp++;
		}
}
*/

int main(void)
{
    Init();
    DiagOut(3,100);

/*	//=== AT+CPBS="SM"     ===
	UART_outstr_P(szATCPBS);
	wait_1ms(250);
	get_num(1);

	UART_ClearRxBuf();

	//=== AT+CPBS="SM"     ===
	UART_outstr_P(szATCPBS);
	wait_1ms(250);
	get_num(2);
*/
/*	UART_ClearRxBuf();

	//=== AT+CPBS="SM"     ===
	UART_outstr_P(szATCPBS);
	wait_1ms(250);
	get_num(3); //  SMSC
*/
	//
	unsigned char i;

	/*sSMSNUM1[0]  = '+';
	sSMSNUM1[1]  = '3';
	sSMSNUM1[2]  = '8';
	sSMSNUM1[3]  = '0';
	sSMSNUM1[4]  = '5';
	sSMSNUM1[5]  = '0';
	sSMSNUM1[6]  = '5';
	sSMSNUM1[7]  = '9';
	sSMSNUM1[8]  = '3';
	sSMSNUM1[9]  = '4';
	sSMSNUM1[10] = '1';
	sSMSNUM1[11] = '3';
	sSMSNUM1[12] = '4';*/

	while(1)
	{
	//UART_outstr_P(sAT1);	UART_outstr(sSMSNUM1);	UART_outstr_P(sAT2);
	//DiagOut(5,250);

	
    //   ID1,ID2, ID3-ID7 (6)
	for(i=0; i<8; i++)
		{
		if(bit_is_clear(PINB, i))
			{
				char c;
				for(c = 0; c<5; c++)
				{
					wait_1ms(40); //   
					if(bit_is_set(PINB, i)) break;
				}
			if(c == 5) //  5      
				{
					if(i == 7) //if(i == 4) //  -  5 
					{
						wait_1s(5);
						if(bit_is_set(PINB, 7)) //      
						continue; //   
					}
					DiagOut(i+1,100);
					testSMS(i);
					continue;
				}
			}
		}


			if(bit_is_clear(PIND, 6)) //ID0
			{
				char c;
				for(c = 0; c<5; c++)
				{
					wait_1ms(40); //   
					if(bit_is_set(PIND, 6)) break;
				}
				if(c == 5) //  5      
				{
					DiagOut(8,100);
					testSMS(8);
					continue;
				}
			}

		} // while(1)

	return 0;
}


void Init(void)
{
  //DDRA=0x00;
  //PORTA=0x00;
 
  DDRB=0x00;
  PORTB=0xFB;

  DDRD=0x22;
  PORTD=0x5D;
  
  UART_Init();
}


//     ,   .. 
void DiagOut(unsigned char n,unsigned int time)
{

	while(n>0)
	{
		sbi(PORTD,5);
		wait_1ms(time);
		cbi(PORTD,5);
		wait_1ms(time);
		n--;
	}
	wait_1s(1);
}


void testSMS(char cause)
{
	PGM_P psz = NULL;
	switch(cause)
	{
	case 0: // 
		psz = sz0;
		break;
	case 1: // 
		psz = sz1;
		break;
	case 2: //  
		psz = sz2;
		break;
	case 3: // 
		psz = sz3;
		break;

	case 4: // 
		psz = sz4;
		break;
	case 5: // 
		psz = sz5;
		break;
	case 6: // 
		psz = sz6;
		break;
	case 7: // 
		psz = sz7;
		break;

	case 8: // 
		psz = sz8;
		break;
	default:
		break;
	}
	if(psz)	//  SMS
	{
	UART_outstr_P(szSTART);		DiagOut(2,250);	//  1 
    UART_outstr_P(psz);			DiagOut(5,250);	//  5/2 
	}	

	// 
	DiagOut(5,25);
	UART_outstr_P(sAT1);	UART_outstr(sSMSNUM1);	UART_outstr_P(sAT2);
	DiagOut(20,250); 		//  10 
	UART_outstr_P(sATH);	DiagOut(3,25);			

	UART_outstr_P(sAT1);	UART_outstr(sSMSNUM2);	UART_outstr_P(sAT2);
	DiagOut(20,250); 		//  10 
	UART_outstr_P(sATH);	DiagOut(5,25);			
	DiagOut(150,250);		DiagOut(150,250);	//  5 
}

                       

void wait_1ms(unsigned char ms)
{
	while(ms)
	{
		short int i;
		for(i=0; i<500; i++)
			inp(PINB);
		ms--;
	}
}

void wait_1s(unsigned char sec)
{
	while(sec)
	{
		wait_1ms(250);
		wait_1ms(250);
		wait_1ms(250);
		wait_1ms(250);
		sec--;
	}
}


void UART_Init(void)
/* initialize uart */
{
	// set baud rate
	UBRRH = (unsigned char) BAUD_19200 >> 8;
	UBRRL = (unsigned char) BAUD_19200;    

	// enable RxD/TxD and ints
    UCSRB = (1<<RXCIE)|( 1 << RXEN )|( 1 << TXEN );
	sei();
}

void UART_outstr_P(PGM_P str)
{
	unsigned char i = 0;
	while(1)
	{
		char c = pgm_read_byte(&str[i]);
		if(!c) break;

		outp(UDR, c);
		loop_until_bit_is_set(UCSRA, UDRE);
		i++;
	}
}

void UART_outstr(char* psz)
{
	unsigned char i = 0;
	while(i < 13)
	{
		char c = psz[i];
		outp(UDR, c);
		loop_until_bit_is_set(UCSRA, UDRE);
		i++;
	}
}


//     
SIGNAL(SIG_USART0_RX)  //SIG_USART0_UDRE    
{	
    arRx[posRx] = UDR;       
	posRx++;
	if(posRx >= SIZERX)
		posRx--;
}

char* UART_Recv(char* pnRecv)
{
	*pnRecv = posRx;
	return arRx;
}

void UART_ClearRxBuf(void)
{
	cli();
	memset(arRx, 0, SIZERX);
	posRx = 0;
	sei();
}
